package jp.co.gihyo.wdpress.vol35;

import static org.jboss.seam.ScopeType.CONVERSATION;

import java.util.List;

import javax.ejb.Remove;
import javax.ejb.Stateful;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import org.jboss.seam.annotations.Begin;
import org.jboss.seam.annotations.Conversational;
import org.jboss.seam.annotations.Destroy;
import org.jboss.seam.annotations.End;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.log.Log;

@Stateful
@Name("register")
@Scope(CONVERSATION)
public class RegisterAction implements Register {

	@In(required = false)
	@Out
	private User user;

	@PersistenceContext
	private EntityManager em;

	@Logger
	private Log log;

	@Begin
	public String start() {
		user = new User();
		return "/register.jsp";
	}

	@Conversational(ifNotBegunOutcome = "/register.jsp")
	public String confirm() {
		return "/confirm.jsp";
	}

	@End
	@Conversational(ifNotBegunOutcome = "/register.jsp")
	public String register() {
		em.persist(user);
		log.info(user.getUsername() + "o^܂B");
		return "/registered.jsp";
	}

	public boolean checkExists(User user) {
		List existing = em.createQuery("select username from User where username=:username").setParameter("username",
				user.getUsername()).getResultList();
		return existing.size() == 0;
	}

	@Destroy
	@Remove
	public void destroy() {
	}
}
