package jp.co.gihyo.wdpress.vol35.test;

import jp.co.gihyo.wdpress.vol35.Register;
import jp.co.gihyo.wdpress.vol35.User;

import org.jboss.seam.Component;
import org.jboss.seam.mock.SeamTest;
import org.testng.annotations.Test;

public class RegisterTest extends SeamTest {

	@Test
	public void test() throws Exception {
		new Script() {
			@Override
			protected void updateModelValues() throws Exception {
				User user = (User) Component.getInstance("user", true);
				assert user != null;
				user.setUsername("kotaro");
				user.setPassword("kota");
				user.setName("Kotaro Iochi");
			}

			@Override
			protected void invokeApplication() {
				Register register = (Register) Component.getInstance("register", true);
				String outcome = register.confirm();
				assert "/confirm.jsp".equals(outcome);
			}

			@Override
			protected void renderResponse() {
				User user = (User) Component.getInstance("user", false);
				assert user != null;
				assert user.getUsername().equals("kotaro");
				assert user.getPassword().equals("kota");
				assert user.getName().equals("Kotaro Iochi");
			}

		}.run();
	}
}
